> This page is for Afterpay Online Developer, version v1.
> For other versions, use one of these documentation indexes:
> - Main (default): https://developers.afterpay.com/afterpay-online-developer/main/llms.txt
> - v1: https://developers.afterpay.com/afterpay-online-developer/v-1/llms.txt
> - Chinese: https://developers.afterpay.com/afterpay-online-developer/chinese/llms.txt

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.afterpay.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.afterpay.com/_mcp/server.

# Create Refund

POST https://global-api-sandbox.afterpay.com/v1/payments/{orderId}/refund/environment:{environment}
Content-Type: application/json

This endpoint performs a full or partial refund.

The refund operation is [idempotent](../../docs/online-api/idempotent-requests.md) if a unique requestId and merchantReference are provided.

### Connection Timeouts
| Timeout |	Time (Seconds) |
| ------- | ------------ |
| Open |	10 |
| Read	| 70 |

Reference: https://developers.afterpay.com/afterpay-online-developer/api-reference/reference/payments/create-refund

## Authentication

- `Authorization` header (basic auth, required) — Basic authentication of the form `Basic <base64(username:password)>`.

## Request

### Path parameters

- `environment` (string, required) — Use `api-sandbox` for AU/NZ, or `api.us-sandbox` for US.
- `orderId` (string, required) — The unique Afterpay Order ID to apply the refund to.

### Headers

- `Accept` (string, optional, default: application/json)

### Body (application/json)

This endpoint expects an object.

- `amount` (V1PaymentsOrderIdRefundEnvironmentEnvironmentPostRequestBodyContentApplicationJsonSchemaAmount, required) — The refund amount. The refund amount can not exceed the payment total.
- `requestId` (string, optional) — A unique request ID, required for safe retries. It is recommended that the merchant generate a UUID for each unique refund.
- `merchantReference` (string, optional) — The merchant’s internal refund id/reference. This must be included along with the `requestId` to utilise idempotency.

## Response

### 201

Returns a Refund object in response. All request parameters will be echoed in the response. In addition, the response includes the following: | Attribute | Type | Description | | --------- | ---- | ----------- | | `refundId` | string | The unique, permanent, Afterpay-generated Refund ID. | | `refundedAt` | string | The UTC timestamp of when the refund was completed, in [ISO 8601](http://www.iso.org/iso/home/standards/iso8601.htm) format. |

## Errors

### 412 Precondition Failed Error

Precondition Failed. The `orderId` is invalid, does not exist, or is not eligible for a refund. For example, the order was declined.

- `any`

### 422 Unprocessable Entity Error

| HTTP Status Code | errorCode | Description | | ---------------- | --------- | ----------- | | Unprocessable Entity | `invalid_amount` | The `amount` requested exceeded the amount available. | | Unprocessable Entity | `unsupported_currency` | The currency of the refund does not match the currency of the order (and the Merchant account). |

- `any`

## Types

### V1PaymentsOrderIdRefundEnvironmentEnvironmentPostRequestBodyContentApplicationJsonSchemaAmount

The refund amount. The refund amount can not exceed the payment total.

- `amount` (string, required, default: 0.00) — The amount as a string representation of a decimal number, rounded to 2 decimal places.
- `currency` (string, required) — The currency in [ISO 4217](https://en.wikipedia.org/wiki/ISO_4217) format. Supported values include "AUD", "NZD" and "USD". However, the value provided must correspond to the currency of the Merchant account making the request.

## Examples

**Request**

```json
{
  "amount": {
    "amount": "25.50",
    "currency": "AUD"
  }
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://global-api-sandbox.afterpay.com/v1/payments/orderId/refund/environment:environment"

payload = { "amount": {
        "amount": "25.50",
        "currency": "AUD"
    } }
headers = {
    "User-Agent": "User-Agent"
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, auth=("<username>", "<password>"))

print(response.json())
```

```javascript
const url = 'https://global-api-sandbox.afterpay.com/v1/payments/orderId/refund/environment:environment';
const credentials = btoa("<username>:<password>");

const options = {
  method: 'POST',
  headers: {
    'User-Agent': 'User-Agent',
    Authorization: `Basic ${credentials}`,
    'Content-Type': 'application/json'
  },
  body: '{"amount":{"amount":"25.50","currency":"AUD"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://global-api-sandbox.afterpay.com/v1/payments/orderId/refund/environment:environment"

	payload := strings.NewReader("{\n  \"amount\": {\n    \"amount\": \"25.50\",\n    \"currency\": \"AUD\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("User-Agent", "User-Agent")
	req.SetBasicAuth("<username>", "<password>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://global-api-sandbox.afterpay.com/v1/payments/orderId/refund/environment:environment")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["User-Agent"] = 'User-Agent'
request.basic_auth("<username>", "<password>")
request["Content-Type"] = 'application/json'
request.body = "{\n  \"amount\": {\n    \"amount\": \"25.50\",\n    \"currency\": \"AUD\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://global-api-sandbox.afterpay.com/v1/payments/orderId/refund/environment:environment")
  .header("User-Agent", "User-Agent")
  .basicAuth("<username>", "<password>")
  .header("Content-Type", "application/json")
  .body("{\n  \"amount\": {\n    \"amount\": \"25.50\",\n    \"currency\": \"AUD\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://global-api-sandbox.afterpay.com/v1/payments/orderId/refund/environment:environment', [
  'body' => '{
  "amount": {
    "amount": "25.50",
    "currency": "AUD"
  }
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'User-Agent' => 'User-Agent',
  ],
    'auth' => ['<username>', '<password>'],
]);

echo $response->getBody();
```

```csharp
using RestSharp;
using RestSharp.Authenticators;

var client = new RestClient("https://global-api-sandbox.afterpay.com/v1/payments/orderId/refund/environment:environment");
client.Authenticator = new HttpBasicAuthenticator("<username>", "<password>");
var request = new RestRequest(Method.POST);
request.AddHeader("User-Agent", "User-Agent");

request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"amount\": {\n    \"amount\": \"25.50\",\n    \"currency\": \"AUD\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let credentials = Data("<username>:<password>".utf8).base64EncodedString()

let headers = [
  "User-Agent": "User-Agent",
  "Authorization": "Basic \(credentials)",
  "Content-Type": "application/json"
]
let parameters = ["amount": [
    "amount": "25.50",
    "currency": "AUD"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://global-api-sandbox.afterpay.com/v1/payments/orderId/refund/environment:environment")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```